"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class SupplementaryAnalysisResults(ProtocolElement):
    """
    This defines a Supplementary Analysis Result
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {
        "contextualAnalysisSubstitutionsCounts",
        "genomicRegionsOfHypermutation",
        "indelAlleleFrequencyHistogramCounts",
        "indelLengthHistogramCounts",
        "mutationalSignatureContribution",
        "sNVAlleleFrequencyHistogramCounts",
    }

    @classmethod
    def getEmbeddedTypes(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_7_7 import metrics as metrics_1_2_2

        return {
            "mutationalSignatureContribution": metrics_1_2_2.MutationalSignatureContribution,
        }

    @classmethod
    def getEmbeddedEnums(cls):
        return {}

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_7_7 import metrics as metrics_1_2_2

        return {
            "org.gel.models.report.avro.MutationalSignatureContribution": metrics_1_2_2.MutationalSignatureContribution,
            "org.gel.models.report.avro.SupplementaryAnalysisResults": metrics_1_2_2.SupplementaryAnalysisResults,
        }

    __slots__ = [
        "contextualAnalysisSubstitutionsCounts",
        "genomicRegionsOfHypermutation",
        "indelAlleleFrequencyHistogramCounts",
        "indelLengthHistogramCounts",
        "mutationalSignatureContribution",
        "sNVAlleleFrequencyHistogramCounts",
    ]

    def __init__(
        self,
        contextualAnalysisSubstitutionsCounts,
        genomicRegionsOfHypermutation,
        indelAlleleFrequencyHistogramCounts,
        indelLengthHistogramCounts,
        mutationalSignatureContribution,
        sNVAlleleFrequencyHistogramCounts,
        validate=None,
        **kwargs
    ):
        """Initialise the metrics_1_2_2.SupplementaryAnalysisResults model.

        :param contextualAnalysisSubstitutionsCounts:
            Counts for each substitution trinucleotide context e.g. {"A[T>A]G":
            117, "G[T>G]C": 39, [...]}
        :type contextualAnalysisSubstitutionsCounts: dict[str, int]
        :param genomicRegionsOfHypermutation:
            Kataegis genomic regions e.g. ["chrY:56829002,56833739",
            "chrX:1813120,1813466", [...]]
        :type genomicRegionsOfHypermutation: list[str]
        :param indelAlleleFrequencyHistogramCounts:
            Indel counts for each allele frequency bin e.g.
            {"(-0.005,0.005]":0,"(0.005,0.015]":0, [...]}
        :type indelAlleleFrequencyHistogramCounts: dict[str, int]
        :param indelLengthHistogramCounts:
            Counts for each indel length e.g. {"(-50,-49]":2,"(-49,-48]":2, [...]}
        :type indelLengthHistogramCounts: dict[str, int]
        :param mutationalSignatureContribution:
            Coefficients for mutational signatures e.g.
            {"coefficients":{"signature1":91.2595, [...]},
            "RSS":0.0063}
        :type mutationalSignatureContribution: MutationalSignatureContribution
        :param sNVAlleleFrequencyHistogramCounts:
            SNVs counts for each allele frequency bin e.g.
            {"(-0.005,0.005]":0,"(0.005,0.015]":0, [...]}
        :type sNVAlleleFrequencyHistogramCounts: dict[str, int]
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "1.2.2"
